<template>
  <v-layout
    fill-height
    wrap
    :justify-end="$vuetify.breakpoint.lgAndUp"
    :justify-center="$vuetify.breakpoint.mdAndDown"
    class="writing-feedback-content"
  >
    <v-flex xs11 lg12>
      <v-card class="pa-2">
        <v-layout
          wrap
          fill-height
          :justify-end="$vuetify.breakpoint.lgAndUp"
          :justify-center="$vuetify.breakpoint.mdAndDown"
          align-start
          class="writing-feedback-content__text pa-2"
        >
          <v-flex xs12>
            <h2 class="gray--text text--darken-2 writing-feedback-content__title">Feedback</h2>
          </v-flex>
          <v-flex xs12 class="writing-feedback-content__tabs">
            <write-tabs :tabs="tabs" @select-tab="selectTab"/>
          </v-flex>
          <v-flex xs12>
            <write-item-text
              @select-word="selectWord"
              :content="sentecesWithColors"
              :active-index="indexOfActiveWord"
            />
          </v-flex>
        </v-layout>
      </v-card>
    </v-flex>
    <v-layout
      align-end
      class="writing-feedback-content__carousel-wrapper"
      :justify-end="$vuetify.breakpoint.lgAndUp"
      :justify-center="$vuetify.breakpoint.mdAndDown"
    >
      <v-flex xs11 lg12 fill-height>
        <v-card class="fill-height">
          <write-carroussel @next="increment" @back="decrement" :content="itemSelectedCarousel"/>
        </v-card>
      </v-flex>
    </v-layout>
  </v-layout>
</template>
<script>
import WriteItemText from './components/WriteItemText';
import WriteCarroussel from './components/WriteCarroussel/Index';
import WriteTabs from './components/WriteTabs';
import SentecesController from './Entity/SentencesController';
import CarouselController from './Entity/CarouselController';

export default {
  props: {
    feedback: {
      type: Object,
      default: () => ({}),
    },
  },
  components: { WriteItemText, WriteTabs, WriteCarroussel },
  data() {
    return {
      carousel: new CarouselController(this.itemsToCarousel),
    };
  },
  methods: {
    increment() {
      this.carousel.increment(this.itemsToCarousel.length);
    },
    decrement() {
      this.carousel.decrement(this.itemsToCarousel.length);
    },
    selectTab(data) {
      const idx = this.itemsToCarousel.findIndex(it => it.rule === data);
      this.setSelected(idx);
    },
    selectWord(data) {
      const idx = this.itemsToCarousel.findIndex(it => it.order === data.order);
      this.setSelected(idx);
    },
    setSelected(index) {
      this.carousel.setIndex(index);
    },
  },
  computed: {
    sentences() {
      return new SentecesController(
        this.feedback.sentence,
        this.feedback.matches,
      );
    },
    itemSelected() {
      return this.itemsToCarousel[this.carousel.index];
    },
    itemSelectedCarousel() {
      return CarouselController.itemSelectedCarousel(
        this.itemSelected,
        this.sentecesWithColors,
      );
    },
    itemsToCarousel() {
      return CarouselController.itemsToCarousel(
        this.sentecesWithColors,
        this.tabs,
      );
    },
    tabs() {
      return this.sentences.createTabs();
    },
    sentecesWithColors() {
      return this.sentences.createText();
    },
    indexOfActiveWord() {
      return this.sentences.indexOfActiveWord(this.itemSelected);
    },
  },
};
</script>
<style lang="sass">
@import ~@/styles/defaults/variables
@import ~@/styles/defaults/mobileFirst

.writing-feedback-content
  max-width: 98%
  &__text
    height: 50vh
  +media-min-lg()
    max-width: 100%
    height: 100%
    &__text
      border: none
    &__title
      font-size: 1em
    &__carousel-wrapper

</style>
